<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { ref, computed, inject } from 'vue';
import { useI18n } from 'vue-i18n';
import PasswordField from '@/components/general/form/PasswordField.vue';
import { request } from '@/lib/request';
import { useRoute, useRouter } from 'vue-router';
import { useBaseStore } from '@/stores/base';
import { storeToRefs } from 'pinia';
import { notificationStatus } from '@/enums/enums';
import Modal from '@/components/general/Modal.vue';

const configuration = inject<any>('configuration');
const adminPassword = ref('');
const adminPasswordValid = ref(true);
const adminPasswordConfirm = ref('');
const adminPasswordConfirmValid = ref(true);
const { t } = useI18n();
const $t = t;

const route = useRoute();
const router = useRouter();

const baseStore = useBaseStore();
const { message, status } = storeToRefs(baseStore);

document.title = $t('adminMenu.passwordReset.label');

const getData = async () => {
    let response = await request('GET', configuration.apiServer + '/api/account/password-reset/' + route.params.id);
    if (response && !response.success) {
        message.value = $t('general.errors.linkExpired');
        status.value = notificationStatus.DANGER;
        router.push({ name: "home" });
    }
};
getData();

const handleSubmit = async () => {
    if (adminPasswordValid || adminPasswordConfirmValid) {
        const data = { adminPassword: adminPassword.value, adminPasswordConfirm: adminPasswordConfirm.value };
        let response = await request('POST', configuration.apiServer + '/api/account/password-reset/' + route.params.id, data);
        if ((response && !response.success) || !response) {
            message.value = $t('adminMenu.passwordReset.error.general');
            status.value = notificationStatus.DANGER;
        }else if(response && response.success){
            message.value = $t('adminMenu.passwordReset.success');
        }
        handleCancel();
    }
};

const handleReset = () => {
    adminPassword.value = '';
    adminPasswordConfirm.value = '';
    adminPasswordValid.value = true;
    adminPasswordConfirmValid.value = true;
};

const handleCancel = ()=>{
    router.push({ name: "home" });
};

const valid = computed(()=>{
    return (adminPassword.value && adminPassword.value.length >= 8 && adminPasswordValid.value === true) && (adminPasswordConfirm.value && adminPasswordConfirm.value.length >= 8 && adminPasswordConfirmValid.value === true) && adminPassword.value == adminPasswordConfirm.value;
});

</script>
<template>
<Modal :header="$t('adminMenu.passwordReset.label')" :labelSubmit="$t('adminMenu.passwordReset.submit')" :disableSubmit="!valid" :labelCancel="$t('general.buttons.cancel')" :labelLeft="$t('general.variables.input') + ' ' + $t('general.variables.reset')" @left="handleReset" @submit="handleSubmit" @cancel="handleCancel">
    <div class="flex flex-col gap-2">
        <PasswordField v-model="adminPassword" v-model:valid="adminPasswordValid" :strong="true"
            :error-text="$t('adminMenu.passwordReset.error.password.strong')"
            :label="$t('general.variables.password.sg')" />
        <PasswordField v-model="adminPasswordConfirm" v-model:valid="adminPasswordConfirmValid"
            :strong="true" :error-text="$t('adminMenu.passwordReset.error.password.strong')"
            :label="$t('general.variables.password.sg') + ' ' + $t('general.variables.confirm')" />
    </div>
</Modal>
</template>
<style scoped>
@media (min-width: 500px) {
    .container {
        max-width: 500px;
        min-width: 500px;
    }
}
</style>